/* MARIN Luciana FLorentina
	332 CB
	*/

#include <avr\io.h>
#include <avr\interrupt.h>
#define F_CPU 16000000
#include <util/delay.h>

#include <string.h>
#include <stdio.h>
#include <stdlib.h>    


// Aprindem ledul 0
void on_led0()
{
	DDRA = 0xff;
	DDRB |= (1 << PB0);
	
	PORTA |= (1 << PA0);
	PORTA &= ~(1 << PA1) & ~(1 << PA2) & ~(1 << PA3) & ~(1 << PA4) & ~(1 << PA5) & ~(1 << PA6) & ~(1 << PA7);
	PORTB &= ~(1 << PB0);
}

// Aprindem ledul 1
void on_led1()
{
	DDRA = 0xff;
	DDRB |= (1 << PB0);
	
	PORTA |= (1 << PA1);
	PORTA &= ~(1 << PA0) & ~(1 << PA2) & ~(1 << PA3) & ~(1 << PA4) & ~(1 << PA5) & ~(1 << PA6) & ~(1 << PA7);
	PORTB &= ~(1 << PB0);
}

// Aprindem ledul 2
void on_led2()
{
	DDRA = 0xff;
	DDRB |= (1 << PB0);
	
	PORTA |= (1 << PA2);
	PORTA &= ~(1 << PA0) & ~(1 << PA1) & ~(1 << PA3) & ~(1 << PA4) & ~(1 << PA5) & ~(1 << PA6) & ~(1 << PA7);
	PORTB &= ~(1 << PB0);
}

// Aprindem ledul 3
void on_led3()
{
	DDRA = 0xff;
	DDRB |= (1 << PB0);
	
	PORTA |= (1 << PA3);
	PORTA &= ~(1 << PA0) & ~(1 << PA1) & ~(1 << PA2) & ~(1 << PA4) & ~(1 << PA5) & ~(1 << PA6) & ~(1 << PA7);
	PORTB &= ~(1 << PB0);
}

// Aprindem ledul 4
void on_led4()
{
	DDRA = 0xff;
	DDRB |= (1 << PB0);
	
	PORTA |= (1 << PA4);
	PORTA &= ~(1 << PA0) & ~(1 << PA1) & ~(1 << PA2) & ~(1 << PA3) & ~(1 << PA5) & ~(1 << PA6) & ~(1 << PA7);
	PORTB &= ~(1 << PB0);
}

// Aprindem ledul 5
void on_led5()
{
	DDRA = 0xff;
	DDRB |= (1 << PB0);
	
	PORTA |= (1 << PA5);
	PORTA &= ~(1 << PA0) & ~(1 << PA1) & ~(1 << PA2) & ~(1 << PA3) & ~(1 << PA4) & ~(1 << PA6) & ~(1 << PA7);
	PORTB &= ~(1 << PB0);
}

// Aprindem ledul 6
void on_led6()
{
	DDRA = 0xff;
	DDRB |= (1 << PB0);
	
	PORTA |= (1 << PA6);
	PORTA &= ~(1 << PA0) & ~(1 << PA1) & ~(1 << PA2) & ~(1 << PA3) & ~(1 << PA4) & ~(1 << PA5) & ~(1 << PA7);
	PORTB &= ~(1 << PB0);
}

// Aprindem ledul 7
void on_led7()
{
	DDRA = 0xff;
	DDRB |= (1 << PB0);
	
	PORTA |= (1 << PA7);
	PORTA &= ~(1 << PA0) & ~(1 << PA1) & ~(1 << PA2) & ~(1 << PA3) & ~(1 << PA4) & ~(1 << PA5) & ~(1 << PA6);
	PORTB &= ~(1 << PB0);
}

// Aprindem ledul 8
void on_led8()
{
	DDRA = 0xff;
	DDRB |= (1 << PB0);
	
	PORTA |= (1 << PB0);
	PORTA &= ~(1 << PA0) & ~(1 << PA1) & ~(1 << PA2) & ~(1 << PA3) & ~(1 << PA4) & ~(1 << PA5) & ~(1 << PA6) & ~(1 << PA7);
}

void on_led(int nr)
{
	switch (nr)
	{
		case 0:
			on_led0();
			break;
		case 1:
			on_led1();
			break;
		case 2:
			on_led2();
			break;
		case 3:
			on_led3();
			break;
		case 4:
			on_led4();
			break;
		case 5:
			on_led5();
			break;
		case 6:
			on_led6();
			break;
		case 7:
			on_led7();
			break;
		case 8:
			on_led8();
			break;
	}
}

// functie pentru aprinderea unui led random
int choose_led() {

	int random_led = rand() % 9;
	
	// stingem orice led aprins anterior
	PORTA = 0x00;
	PORTB &= ~(1 << PB0);
	_delay_ms(100);
	
	// aprindem un led ales random
	if(random_led == 0){
		PORTA |= (1 << PA0);
		return random_led;
	}
	if(random_led == 1){
		PORTA |= (1 << PA1);
		return random_led;
	}
	if(random_led == 2){
		PORTA |= (1 << PA2);
		return random_led;
	}
	if(random_led == 3){
		PORTA |= (1 << PA3);
		return random_led;
	}
	if(random_led == 4){
		PORTA |= (1 << PA4);
		return random_led;
	}
	if(random_led == 5){
		PORTA |= (1 << PA5);
		return random_led;
	}
	if(random_led == 6){
		PORTA |= (1 << PA6);
		return random_led;
	}
	if(random_led == 7){
		PORTA |= (1 << PA7);
		return random_led;
	}
	if(random_led == 8){
		PORTB |= (1 << PB0);
		return random_led;
	}
	
	return random_led;

}

int main()
{

	int game_diff = 0;
	int start_game = 0;
    int randomize = 0;
	
	// Aprinem ledul alb de schimbare dificultate ca initializare
	DDRA = 0xff;
	DDRB |= (1 << PB2);
	PORTB |= (1 << PB2);
	_delay_ms(100);
	
	// PB2 = buton de start game
	DDRD &= ~(1 << PB2);
	PORTD |= (1 << PB2);
	_delay_ms(100);
	
	
	//PB1 = buton de schimbare dificultate
	DDRD &= ~(1 << PB1);
	PORTD |= (1 << PB1);
	_delay_ms(100);
	
	while(1)
	{		
  
        randomize += 3;
		
		// Calculez de cate ori am apasat pe butonul de schimbare dificultate
		if (! (PIND & (1 << PB1)))
		{
			game_diff++;
		}
		_delay_ms(100);
		
		// Calculez de cate ori am apasat pe butonul de start game
		if (! (PIND & (1 << PB2)))
		{
			start_game++;
		}
        
        srand (randomize);
        
        if (start_game % 2 == 0)
        {
            //reset game
			PORTA &= ~(1 << PA0) & ~(1 << PA1) & ~(1 << PA2) & ~(1 << PA3) & ~(1 << PA4) & ~(1 << PA5) & ~(1 << PA6) & ~(1 << PA7);
			PORTB &= ~(1 << PB0);
        } else {
            //start game, incep sa aprind ledurile random
            on_led(rand() % 9);
            _delay_ms(10);
        }

		
		
		// Functie care verifica daca am apasat pe butonul corect.
		
	}
	
	return 0;
}
